#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_JuKunShopCFG.h"
std::auto_ptr<Fish_JuKunShopCFG> Fish_JuKunShopCFG::msSingleton(nullptr);

int Fish_JuKunShopCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_JuKunShopCFGData* Fish_JuKunShopCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_JuKunShopCFGData>& Fish_JuKunShopCFG::GetMapData()
{
	return mMapData;
}

void Fish_JuKunShopCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_JuKunShopCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_JuKunShopCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mShopName = element->Attribute("ShopName");
		data.mShopItem = element->IntAttribute("ShopItem");
		data.mShopNumber = element->IntAttribute("ShopNumber");
		data.mNeedKunCoin = element->IntAttribute("NeedKunCoin");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_JuKunShopCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JuKunShopCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_JuKunShopCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_JuKunShopCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_JuKunShopCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readString(L, "ShopName", data.mShopName);
		LuaCfgHelper::readInt(L, "ShopItem", data.mShopItem);
		LuaCfgHelper::readInt(L, "ShopNumber", data.mShopNumber);
		LuaCfgHelper::readInt(L, "NeedKunCoin", data.mNeedKunCoin);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_JuKunShopCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JuKunShopCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_JuKunShopCFG* Fish_JuKunShopCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_JuKunShopCFG());
	}
	return msSingleton.get();
}

void Fish_JuKunShopCFG::Release()
{
	msSingleton.reset(nullptr);
}
